#ifndef __GeometricObject__
#define __GeometricObject__

#include "from_book/Ray.h"
#include "from_book/Ray.cpp"

#include "from_book/Vector3D.h"
#include "from_book/Vector3D.cpp"

#include "from_book/Point3D.h"
#include "from_book/Point3D.cpp" 

#include "from_book/Normal.h"
#include "from_book/Normal.cpp"

#include "from_book/RGBColor.h"
#include "from_book/RGBColor.cpp"

//#include "Matte.h"

class Phong;

#include "ShadeRec.h"
#include "ShadeRec.cpp"

#include<string>

using namespace std;


class GeometricObject{
	public:
		virtual bool hit(const Ray ray, double &t, ShadeRec *sr)  = 0;
		virtual RGBColor get_color() = 0;
		void set_material(Phong * in_material);
		Phong * get_material();
		string name;
		RGBColor color;
		Phong * material;
	protected:
		static const double kEpsilon = 0.0001;
		
};


Phong *  GeometricObject :: get_material(){
	return material;
}


void GeometricObject :: set_material(Phong * in_material){
	material = in_material;
}

#endif
