#ifndef __GLOSSY__
#define __GLOSSY__

#include "BRDF.h"

class GlossySpecular : public BRDF{

	public: 
		GlossySpecular();
		void set_exp(float in_exp);
		virtual RGBColor f (const ShadeRec &sr, const Vector3D &wi, const Vector3D &wo) const;
		virtual RGBColor rho(const ShadeRec &sr, const Vector3D &wo)const;

	private:
		float ks, exp;
		RGBColor cd;
};

GlossySpecular :: GlossySpecular(){
	ks = 1.0; //TODO this is experimental
}

void GlossySpecular :: set_exp(float in_exp){
	exp = in_exp;
}

RGBColor GlossySpecular :: rho(const ShadeRec &sr, const Vector3D &wo) const{
	return (ks * cd);
}

RGBColor GlossySpecular :: f(const ShadeRec & sr, const Vector3D & wo, const Vector3D & wi) const{
	
	RGBColor L;
	float ndotwi = sr.normal * wi;
	Vector3D r(-wi + 2.0 * sr.normal * ndotwi);
	float rdotwo = r * wo;
	
	if (rdotwo > 0.0)
	{
		L = ks * (pow(rdotwo, exp));
	}
	
	return L;
}

#endif
