#ifndef __LAMBERTIAN__
#define __LAMBERTIAN__

#include "BRDF.h"
#include "from_book/Constants.h"

class Lambertian : public BRDF{
	
	public:
		virtual RGBColor f (const ShadeRec &sr, const Vector3D &wi, const Vector3D &wo) const;
		//virtual RGBColor sample_f(const ShadeRec &sr, Vector3D &wi, const Vector3D &wo) const;
		virtual RGBColor rho(const ShadeRec &sr, const Vector3D &wo)const;
		
		void set_kd(float input);
		void set_cd(RGBColor input);
		
	private:
		float kd;
		RGBColor cd;
	
};

void Lambertian :: set_kd(float input){
	kd = input;
}
void Lambertian :: set_cd(RGBColor input){
	cd = input;
}

RGBColor Lambertian :: f(const ShadeRec &sr, const Vector3D &wi, const Vector3D &wo) const{
	return (kd * cd * invPI);
}

RGBColor Lambertian :: rho(const ShadeRec &sr, const Vector3D &wo) const{
	return (kd * cd);
}
#endif
