#include <iostream> // cout
#include "Plane.h"

using namespace std; // Standard Template Library
// 
Plane::Plane(){
	cout << "no argument constructor";
	return;
}

Plane::Plane(Point3D in_point, Normal in_normal){
	point = in_point;
	normal = in_normal;
	//kEpsilon = 0.0001;
	cout << "2 argument constructor";
	return;
}

bool Plane::hit(const Ray ray, double &tmin, ShadeRec * sr){
	double t = (point - ray.o) * normal / (ray.d * normal);	
	
	//cout << "Inside Hit";
	
	if (t > kEpsilon){
		tmin = t;
		sr->normal = normal;
		sr->local_hit_point = ray.o + t * ray.d;
		return true;
	}
	
	else{
		return false;
	}
}

RGBColor Plane :: get_color(){
	return color;
}

void Plane :: set_color(RGBColor in_color){
	
	color = in_color;
}

/*
int main(){
	int x = 3;
	int normal = 5;
	double mydouble = 0.13;
	Ray myRay;
	Point3D myPoint;
	
	Plane Myplane(3, 1);
	//Myplane = new Plane(3, 5);
	cout << "\n\n" << Myplane.hit(myRay, mydouble, &myPoint);
	
}
*/
