#ifndef __POINTLIGHT__
#define __POINTLIGHT__
class PointLight : public Light {
	
	public:
		virtual Vector3D get_direction(ShadeRec &sr);
		virtual RGBColor L(const ShadeRec &sr) const;
		void set_location(Vector3D input);
		void scale_radiance(float scale_factor);
		void set_color(RGBColor in_color);
		RGBColor get_color(void);
		
	private:
		float ls;
		RGBColor color;
		Vector3D location;
};

Vector3D PointLight :: get_direction(ShadeRec &sr){
	return ((location - sr.hit_point).hat());
}

RGBColor PointLight :: L(const ShadeRec &sr) const{
	return (ls * color);
}

void PointLight :: set_location(Vector3D input){
	location = input;
}

void PointLight :: scale_radiance(float scale_factor){
	color = color * scale_factor;
}

void PointLight :: set_color(RGBColor in_color){
	color = in_color;	
}

RGBColor PointLight :: get_color(void){
	return color;
}

#endif

