#include <iostream>
#include "Sphere.h"

using namespace std;

Sphere::Sphere(){
	cout << "no argument constructor";
	name = "sphere";
	return;		
}

Sphere :: Sphere(Point3D in_centerPoint, float in_Radius){
	centerPoint = in_centerPoint;
	name = "sphere";
	Radius = in_Radius;
}

int Sphere :: set_color(RGBColor ColorIn){
	rgbcolor = ColorIn;
	return 0;
}

RGBColor Sphere :: get_color(){
	return rgbcolor;
}

bool Sphere :: hit (Ray ray, double &tmin, ShadeRec *sr){
	
	//cout << "inside sphere.hit()" ;
	
	// Just like how I solved this on homework 2
	// and like it is presented in the Suffern book...
	double t;
	Vector3D temp 	= ray.o - centerPoint;
	double a 	= ray.d * ray.d;
	double b 	= 2.0 * temp * ray.d;
	double c 	= temp * temp - Radius * Radius;
	double disc	= b * b - 4.0 * a * c;
	
	if (disc < 0.0){
		return false;
	}
	else{
		double e = sqrt(disc);
		double denom = 2.0 * a;
		t = (-b - e) / denom; // smaller root
		
		if (t > kEpsilon){
			tmin = t; 
			 sr->normal = (temp + t * ray.d) / Radius;
			 sr->local_hit_point = ray.o + t * ray.d;
			 return true;		
		}
	
		t = (-b + e) / denom; // larger root
		if (t > kEpsilon){
			tmin = t; 
			sr->normal = (temp + t * ray.d) / Radius;
			sr->local_hit_point = ray.o + t * ray.d;
			return true;		
		}
	}
	return false;
}

/*
int main(){
	
	Point3D myPoint, myPointX;
	Ray myRay;
	float radius = 3.0;
	double myDouble = 0.13;
	
	Sphere mySphere(myPoint, radius);
	cout << mySphere.hit(myRay, myDouble, &myPointX);
		
}
*/
