#ifndef __TRACER__
#define __TRACER__

class Tracer{
	public:
		Tracer (void);
		Tracer(World * _world_ptr);
		virtual RGBColor trace_ray(const Ray & ray) const;
		virtual RGBColor trace_ray(const Ray & ray, const int depth) const;
		virtual RGBColor trace_ray(const Ray & ray, float &tmin, const int depth) const;
		
	protected:
		World * world_ptr;
		
};


RGBColor RayCast :: trace_ray(const Ray ray, const int depth) const {
	
	ShadeRec sr (world_ptr->hit_objects(ray)); // copy constructor
	
	if (sr.hitAnObject){
		sr.ray = ray;  // For specular reflection - coming soon!
		return (sr.material_ptr->shade(sr));
	}
	else{
		return (world_ptr->background_color);
	}
}


#endif