#include <iostream>
#include "Triangle.h"

using namespace std;

Triangle :: Triangle(){
	cout << "no argument constructor";
	name = "Triangle";
	v0 = (0,0,0);
	v1 = (0,0,1);
	v2 = (1,0,0);
	normal = Normal(0,1,0);
}


Triangle :: Triangle(Point3D a, Point3D b, Point3D c){
	v0 = a;
	v1 = b;
	v2 = c;
}

bool Triangle :: hit(Ray ray, double &tmin, ShadeRec *sr){
	// Straight from Suffern
	// I did this in ActionScript, but didn't want to spend a bunch of
	// time debugging C++, thanks Suffern.
		
	double a = v0.x - v1.x, b = v0.x - v2.x, c = ray.d.x, d = v0.x - ray.o.x;
	double e = v0.y - v1.y, f = v0.y - v2.y, g = ray.d.y, h = v0.y - ray.o.y;
	double i = v0.z - v1.z, j = v0.z - v2.z, k = ray.d.z, l = v0.z - ray.o.z;
	
	double m = f * k - g * j, n = h * k - g * l, p = f * l - h * j;
	double q = g * i - e * k, s = e * j - f * i;
	
	double inv_denom = 1.0 / (a * m + b * q + c * s);
	
	double e1 = d * m - b * n - c * p;
	double beta = e1 * inv_denom;
	
	if (beta < 0.0){
		return (false);
	}
	
	double r = e * l - h * i;
	double e2 = a * n + d * q + c * r;
	double gamma = e2 * inv_denom;
	
	if (gamma < 0.0){
		return (false);
	}
	
	if (beta + gamma > 1.0){
		return (false);
	}
	
	double e3 = a * p - b * r + d * s;
	double t = e3 * inv_denom;
	
	if (t < kEpsilon){
		return (false);
	}
	
	tmin = t;
	sr->normal = normal;
	sr->local_hit_point = ray.o + t * ray.d;
	
	return (true);	
}

RGBColor Triangle :: get_color(){
	return rgbcolor;
}

void Triangle :: set_color(RGBColor inColor){
	rgbcolor = inColor;
}
