#ifndef __WORLD__
#define __WORLD__

#include <vector>

#include "from_book/ViewPlane.h"
#include "from_book/ViewPlane.cpp"

#include "from_book/RGBColor.h"

#include "from_book/Tracer.h"
#include "from_book/Tracer.cpp"

#include "from_book/Ray.h"
#include "ShadeRec.h"

#include "GeometricObject.h"

#include "myViewPlane.h"
#include "Light.h"
#include "Ambient.h"

class World{
	
	public :
		//World();
		myViewPlane			vp;
		RGBColor			background_color;
		Ambient * ambient_ptr;
		Tracer*				tracer_ptr;
		
		vector<GeometricObject*>	objects;
		vector<Light*>			lights;
		
		
		ofstream myfile;
		
		void build(void);
		
		void build_example(void);
		
		
		void add_object(GeometricObject * object_ptr);
		void add_light(Light * light_ptr);
		
		ShadeRec hit_bare_bones_objects(const Ray &ray);
		
		
			
		void render_scene(void) const;
		
		void build_ppm_file(myViewPlane ViewPlane);
		void write_to_ppm_file(RGBColor pixel_color);
		
		int charCounter;
		myViewPlane ViewPlane;
		
		void set_ambient_light(Ambient *in);
		
	private:
		int s; // pixel size
		
		
};

inline void World :: add_object(GeometricObject * object_ptr){
	objects.push_back(object_ptr);
}

inline void World :: add_light(Light * light_ptr){
	lights.push_back(light_ptr);
}

#endif
