#include "Sphere.cpp"
#include "Plane.cpp"
#include <fstream>
#include "World.h"
#include "myViewPlane.cpp"
#include "myViewPlane.h"
#include "from_book/Point2D.cpp"

// This isn't working. I only have three objects, I might as well do this object by object and get this working later.


World :: World(){
	
	//cout << "No argument constructor for World\n";
	s = 1; // pixel size = 1 
	return;
}


RGBColor World :: hit_bare_bones_objects(const Ray & ray) {
	ShadeRec sr (*this);
	double t = 0;
	double tmin	=kHugeValue;
	int num_objects = objects.size();
	RGBColor tmpColor;
	tmpColor.r = 0;
	tmpColor.g = 0;
	tmpColor.b = 0;
		
	
	for (int j = 0; j < num_objects; j++){		
		if (objects[j]->hit(ray, t, sr) && (t < tmin)){
		//	cout << "HIT\n";
			sr.hit_an_object = true;
			tmin = t;
			tmpColor = objects[j]->get_color();
			//cout << "tmpColor.r = " << tmpColor.r ;
			//cout << "tracing a ray\n";			
		}
		
	}
	return tmpColor;
}


int main(){

	Point3D sphereCenter = (2, 2, .2);
	World myWorld;
	myWorld.tracer_ptr = new Tracer();
	
	Sphere *mySphere = new Sphere(sphereCenter, .3);
	mySphere->set_color(RGBColor(1,0,0)); // red
	myWorld.add_object(mySphere);
	//red Sphere centered at 0,0,0 with 85 radius.
	
	
	myViewPlane ViewPlane;
	ViewPlane.hres =512;
	ViewPlane.vres =512;
	ViewPlane.eyePoint = Point3D(0,4,2);
	ViewPlane.eye_at = Point3D(0,0,0);
	ViewPlane.eye_up = Point3D(0,0,1);
	ViewPlane.distance_to_eye = 1;
	ViewPlane.s = 1;
	
	ViewPlane.CalculateCenterPoint();
	ViewPlane.CalculateBottomLeft();
	ViewPlane.CalculateBottomRight();
	ViewPlane.CalculateTopRight();
	ViewPlane.CalculateTopLeft();
	
	Sphere * sphere_ptr = new Sphere(Point3D(0,100,0),1.0);
	sphere_ptr->set_color(RGBColor(1,1,0)); // yellow
	//myWorld.add_object(sphere_ptr);
	// yellow Sphere centered 0,30,0 with radius 60
		
	Plane * plane_ptr = new Plane(Point3D(0,0,0), Normal(0,0,1));
	plane_ptr->set_color(RGBColor(0.5,0.5,1.0)); 
	//myWorld.add_object(plane_ptr);
			
	//myWorld.objects[1]->color = RGBColor(1,1,0);
	
	
	Ray ray;
	double zw = 100.0;
	double x,y;
	
	ShadeRec sr (myWorld);
	
	double t;
	Point3D p;
	
	/*
	int viewPlane_verticle = 700;
	int viewPlane_horizontal = 700;
	float viewPlane_pixelSize = 1.0;
	*/
	int charCounter = 0; // ppm should only have 70 chars per line
	
	RGBColor pixel_color;
	
	ofstream myfile;
	myfile.open ("example.ppm");
	myfile << "P3\n";
	myfile << "# Ray tracer output file\n";
	myfile << ViewPlane.hres << " " << ViewPlane.vres << "\n"; // width height
	myfile << "255 \n"; // Max intensity
	
	
	Point2D pp; // sample point on a pixel
	
	// Old stuff
	//ray.d = Vector3D(0,0,-1);
	
	// Start our ray at the eye position
	ray.o = ViewPlane.eyePoint;
	ViewPlane.compute_uvw();
	
	// OK, I am going across all the pixels. I need to translate
	// this from screen space to world space.
	
	cout << "\nViewPlane.across.x = " <<ViewPlane.across.x << "\n";
	cout << "ViewPlane.across.y = " <<ViewPlane.across.y << "\n";
	cout << "ViewPlane.across.z = " <<ViewPlane.across.z << "\n\n";
	
	cout << "ViewPlane.eye_up.x = " << ViewPlane.eye_up.x << "\n";
	cout << "ViewPlane.eye_up.y = " << ViewPlane.eye_up.y << "\n";
	cout << "ViewPlane.eye_up.z = " << ViewPlane.eye_up.z << "\n\n";
	
	cout << "ViewPlane.eye_at_vec.x " << ViewPlane.eye_at_vec.x << "\n";
	cout << "ViewPlane.eye_at_vec.y " << ViewPlane.eye_at_vec.y << "\n";
	cout << "ViewPlane.eye_at_vec.z " << ViewPlane.eye_at_vec.z << "\n\n";
	
	for (int r = 0; r < ViewPlane.vres; r++) // up
	{
		// across
		for (int c = 0 ; c< ViewPlane.hres; c++){
			
			Vector3D tmp_vec;
			Point3D  pt_tmp;
			
			if ( (c < (ViewPlane.hres / 2 ))){
				pt_tmp = (ViewPlane.across * ViewPlane.centerPoint) *
						(c / ViewPlane.hres);
			}
			else{
				pt_tmp = (-ViewPlane.across * ViewPlane.centerPoint) *
						(c / ViewPlane.hres);
			}
			
			if ((r < ViewPlane.vres / 2)) {
				pt_tmp = ((ViewPlane.eye_up * pt_tmp) * (r / ViewPlane.hres));
			}
			else{
				pt_tmp = ((-ViewPlane.eye_up * pt_tmp) * (r / ViewPlane.hres));
				
			}
			
			ray.d = (pt_tmp - ViewPlane.eyePoint);
			//ray.d.normalize();
			
			pixel_color = myWorld.hit_bare_bones_objects(ray);

			myfile << " " << (ceil( 255 * pixel_color.r)) << " " << (ceil( 255 * pixel_color.g)) << " " << (ceil( 255 * pixel_color.b)) << " ";
			//myfile << 255 * mySphere->hit(ray, t, &p) << " 0 0 ";
			charCounter = charCounter +6; 
			if (charCounter >= 60){
				//cout << "NEWLINE PRINTED";
				myfile << "\n";
				charCounter = 0;
			}
			
			// printf("%d",mySphere->hit(ray, t, &p));
			//printf("%f ",t); 			
		}
		
		
	} printf("\n");
	myfile.close();
}
