#include "myViewPlane.h"

void myViewPlane :: CalculateCenterPoint(){
	
	debug = false;
	
	// Calculate it
	eye_at_vec  = eye_at - eyePoint;
		
	// Normalize
	eye_at_vec.normalize();
		
	//cout << "distance_to_eye = " << distance_to_eye << "\n\n";
	// Multiply by the distance from the eye to the plane.
	
	
	centerPoint = 	Point3D(eye_at_vec.x * distance_to_eye, eye_at_vec.y * 
			distance_to_eye, eye_at_vec.z * distance_to_eye);
	
	centerPoint = centerPoint + eyePoint;
	
	if (debug){
		cout << "CenterPoint.x = " << centerPoint.x << "\n";
		cout <<	"CenterPoint.y = " << centerPoint.y << "\n";
		cout << "CenterPoint.z = " << centerPoint.z << "\n\n";
	}
	
}

void myViewPlane :: CalculateBottomLeft(){
	
	Vector3D tmpx, tmpy;
	Vector3D tmp_pt;
	eye_at_vec = eye_at - eyePoint;
	
	across = eye_up ^ eye_at_vec;
	
	tmpx = across;
	tmpx.normalize();
	
	tmp_pt = tmpx + centerPoint;		
	
	tmpy = eye_up;
	tmpy.normalize();
	tmp_pt = tmp_pt - tmpy;
	
	bottom_left.x = tmp_pt.x;
	bottom_left.y = tmp_pt.y;
	bottom_left.z = tmp_pt.z; 
	
	if (debug){
		cout << "Bottom_Left.x = " << bottom_left.x << "\n";
		cout << "Bottom_Left.y = " << bottom_left.y << "\n";
		cout << "Bottom_Left.z = " << bottom_left.z << "\n\n";;
	}
			
}

void myViewPlane :: CalculateTopLeft(){
	
	Vector3D tmpx, tmpy;
	Vector3D tmp_pt;
	
	across = eye_up ^ eye_at_vec;
	
	tmpx = across;
	tmpx.normalize();		
	
	tmp_pt = tmpx + centerPoint;
		
	tmpy = eye_up;
	tmpy.normalize();
	tmp_pt = tmp_pt + tmpy;
	
	top_left.x = tmp_pt.x;
	top_left.y = tmp_pt.y;
	top_left.z = tmp_pt.z; 
	
	if (debug){
		cout << "top_left.x = " << top_left.x << "\n";
		cout << "top_left.y = " << top_left.y << "\n";
		cout << "top_left.z = " << top_left.z << "\n\n";;
	}
			
}

void myViewPlane :: CalculateBottomRight(){
	Vector3D tmpx, tmpy;
	Vector3D tmp_pt;
		
	across = eye_up ^ eye_at_vec;
	
	tmpx = across;
	tmpx.normalize();		
	tmpx = tmpx;	
	tmp_pt = (-tmpx) + centerPoint;
		
	tmpy = eye_up;
	tmpy.normalize();
	tmp_pt = tmp_pt - tmpy;
	
	bottom_right.x = tmp_pt.x;
	bottom_right.y = tmp_pt.y;
	bottom_right.z = tmp_pt.z;
	
	if (debug){
		cout << "Bottom_Right.x = " << bottom_right.x << "\n";
		cout << "Bottom_Right.y = " << bottom_right.y << "\n";
		cout << "Bottom_Right.z = " << bottom_right.z << "\n\n";
	}
	
}

void myViewPlane :: CalculateTopRight(){
	Vector3D tmpx, tmpy;
	Vector3D tmp_pt;
		
	across = eye_up ^ eye_at_vec;
	
	tmpx = across;
	tmpx.normalize();			
	tmp_pt = (-tmpx) + centerPoint;
		
	tmpy = eye_up;
	tmpy.normalize();
	tmp_pt = tmp_pt + tmpy;
	
	top_right.x = tmp_pt.x;
	top_right.y = tmp_pt.y;
	top_right.z = tmp_pt.z;
	
	if (debug){
		cout << "Top_Right.x = " << top_right.x << "\n";
		cout << "Top_Right.y = " << top_right.y <<"\n";
		cout << "Top_Right.z = " << top_right.z << "\n\n";
	}
	
}

Vector3D myViewPlane :: ray_Direction(float x, float y) {
	Vector3D dir = x * u + y * v - distance_to_eye * w;
	dir.normalize();
	return (dir);
	
}

void myViewPlane :: calculate_from_bottom_left(){
	Vector3D across_2;
	Vector3D up_2;
	Point3D tmp;
	
	across.normalize();
	eye_up.normalize();
	
	across_2 = 2 * across;
	up_2 = 2 * eye_up;
	tmp = bottom_left + up_2;
	
	cout << "Top_Left (from b-l).x = " << tmp.x << "\n";
	cout << "Top_Left (from b-l).y = " << tmp.y << "\n";
	cout << "Top_Left (from b-l).z = " << tmp.z << "\n\n";
	
	
	
	
	
}

Point3D myViewPlane :: from_screen_to_world(int x, int y){
	
	bool debug = false;
	
	Point3D myPt; // tmp pt
	
	CalculateCenterPoint();
	CalculateBottomLeft();
	
	myPt = bottom_left; // set it to bottom left
	
	if (debug){
		cout << "IN from_screen_to_world\n";
		cout << "	myPt.x = " << myPt.x << "\n";
		cout << "	myPt.y = " << myPt.y << "\n";
		cout << "	myPt.z = " << myPt.z << "\n\n";
	}
	
	across = eye_at_vec ^ eye_up;
	across.normalize();
	
	if (debug){
		cout << "	across.x = " << across.x << "\n";
		cout << "	across.y = " << across.y << "\n";
		cout << "	across.z = " << across.z << "\n\n";
	}
	
	across_from_bl = 2 * across;
	if (debug){
		cout << "	across_from_bl.x = " << across_from_bl.x << "\n";
		cout << "	across_from_bl.y = " << across_from_bl.y << "\n";
		cout << "	across_from_bl.z = " << across_from_bl.z << "\n\n";
	}
	
	up_from_bl = 2 * eye_up;
	if (debug){
	cout << "	up_from_bl.x = " << across_from_bl.x << "\n";	
	cout << "	up_from_bl.y = " << across_from_bl.y << "\n";
	cout << "	up_from_bl.z = " << across_from_bl.z << "\n\n";
	}
	
	
	float x_f, y_f, hres_f, vres_f;
	x_f = (float)x;
	y_f = (float)y;
	hres_f = (float) hres;
	vres_f = (float) vres;
	
	if (debug){
		cout << "	float x_f = " << x_f << "\n";
		cout << "	float y_f = " << y_f << "\n";
		cout << "	float hres_f = " << hres_f << "\n";
		cout << "	float vres_f = " << vres_f << "\n";
	}
	
	
	myPt = myPt + ( (x_f / hres_f) * across_from_bl); // get our across
	myPt = myPt + ((y_f / vres_f)  * up_from_bl); // verticle
	
	
	return myPt;
	

	
}

void myViewPlane :: test_from_screen_to_world(){
	
	CalculateCenterPoint();
	
	Point3D tmp;
	cout << "\n\n\n*****\n";
	cout << " hres" << hres << "\n\n";
	cout << " vres" << vres << "\n\n";
	tmp = from_screen_to_world(0,0);
	cout << "bottom_Left *.x = " << tmp.x << "\n";
	cout << "bottom_Left *.y = " << tmp.y << "\n";
	cout << "bottom_Left *.z = " << tmp.z << "\n\n";
	tmp = from_screen_to_world(0,512);
	cout << "Top_Left *.x = " << tmp.x << "\n";
	cout << "Top_Left *.y = " << tmp.y << "\n";
	cout << "Top_Left *.z = " << tmp.z << "\n\n";
	tmp = from_screen_to_world(512,0);
	cout << "Bottom_Right *.x = " << tmp.x << "\n";
	cout << "Bottom_Right *.y = " << tmp.y << "\n";
	cout << "Bottom_Right *.z = " << tmp.z << "\n\n";
	tmp = from_screen_to_world(512,512);
	cout << "Top_Right *.x = " << tmp.x << "\n";
	cout << "Top_Right *.y = " << tmp.y << "\n";
	cout << "Top_Right *.z = " << tmp.z << "\n\n";	
	
	tmp = from_screen_to_world(256,256);
	cout << "Mid *.x = " << tmp.x << "\n";
	cout << "Mid *.y = " << tmp.y << "\n";
	cout << "Mid *.z = " << tmp.z << "\n\n";	
	
	cout << "\n\n\n*****\n";

	
	
}

void myViewPlane :: compute_uvw(void){
	w = eyePoint - eye_at;
	w.normalize();
	u = eye_up ^ w;
	u.normalize();
	v = w ^ u;
	v.normalize();
}
